// in2cat.cpp : Legt die Initialisierungsroutinen fr die DLL fest.
//
//		Version 2,x
//		(c) 2003 by Dimitri Junker
//			Adenauerallee 30
//			52066 Aachen	
//		Dieses File ist Teil des In2Cat-Projektes und steht unter der
//		In2Cat Public License. Dementspechend ist es Freeware und darf
//		entsprechend der o.g. Liscense weitergegeben und verndert werden.
//		Eine Kopie der In2Cat Public License liegt diesem Paket bei
//		Diese Copyright Meldung darf nur vom Copyright Inhaber gendert werden.
//
/* -------------------------------------------------------------------- */
/*		Includes														*/
/* -------------------------------------------------------------------- */
#include "stdafx.h"
//#include <afxdllx.h>
//#include <afxsock.h>
#include "in2cat.h"
#include "TimeOutSocket.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "windows.h"

#include <ras.h>
#include <raserror.h>
#include "ESELINCONN.h"
#include "ehangup.h"
/* -------------------------------------------------------------------- */
/*       Makros. & Konstanten                                           */
/* -------------------------------------------------------------------- */

#define DLL_ABW_VERS 206
#define DLL_VERS 206
/* -------------------------------------------------------------------- */
/*		typedefs														*/
/* -------------------------------------------------------------------- */
typedef struct
{
	CString name;
	BOOL	showStar;
}SELCONN_DAT;
/* -------------------------------------------------------------------- */
/* 		lokale Funktionsprototypen										*/
/* -------------------------------------------------------------------- */

	static void win_sock_init(MPS_motregs *r);
	static void win_socket(MPS_motregs *r);
	static void win_connect(MPS_motregs *r);
	static void win_send(MPS_motregs *r);
	static void win_recvfrom(MPS_motregs *r);
	static void win_sclose(MPS_motregs *r);
	static void win_gethostname(MPS_motregs *r);
	static void win_shutdown(MPS_motregs *r);
	static void win_connectC(MPS_motregs *r);
	static void win_inet_addr(MPS_motregs *r);
	static void dll_version(MPS_motregs *r);
	static void win_hasConn2In(MPS_motregs *r);
	static void win_selConn(MPS_motregs *r);
	static void win_dial(MPS_motregs *r);
	static void win_hangUp(MPS_motregs *r);
	static void dll_versionAbwC(MPS_motregs *r);
	static void winT_selConn(MPS_motregs *r);
	static void winT_dial(MPS_motregs *r);
	static void init_clock(MPS_motregs *r);
	static void win_clock(MPS_motregs *r);
	static void win_gethostIP(MPS_motregs *r);	//DYJ 1.07a 
	static void win_lstErr(MPS_motregs *r);//DYJ 1.07b 
	static void win_create(MPS_motregs *r);//DYJ 1.07b 


	SOCKADDR *convSockAddr(SOCKADDR_IN *lpSockAddrZ,long motAddr);

/* -------------------------------------------------------------------- */
/*		Globale Variablen												*/
/* -------------------------------------------------------------------- */
//	static AFX_EXTENSION_MODULE MpcsockDLL = { NULL, NULL };
	MPS_magicinfo m_info;					// global fr die DLL
	MPS_fuptr my_funclist[] = 
	{
		win_sock_init,
		win_socket,
		win_connect,
		win_send,
		win_recvfrom,
		win_sclose,
		win_shutdown,
		win_gethostname,
		win_connectC,
		win_inet_addr,
		dll_version,
		win_hasConn2In,
		win_selConn,
		win_dial,
		win_hangUp,
		dll_versionAbwC,
		winT_selConn,
		winT_dial,
		init_clock,
		win_clock,
		win_gethostIP,	//DYJ 1.07a 
		win_lstErr,		//DYJ 1.07b 
		win_create,		//DYJ 1.07b 
		NULL
	};
	HRASCONN hRasConn;
	int ThreadStatus=0;
	int ThreadReturn;
/* -------------------------------------------------------------------- */
/*		Funktionen														*/
/* -------------------------------------------------------------------- */


//
//	Beachten Sie!
//
//		Wird diese DLL dynamisch an die MFC-DLLs gebunden,
//		muss bei allen von dieser DLL exportierten Funktionen,
//		die MFC-Aufrufe durchfhren, das Makro AFX_MANAGE_STATE
//		direkt am Beginn der Funktion eingefgt sein.
//
//		Beispiel:
//
//		extern "C" BOOL PASCAL EXPORT ExportedFunction()
//		{
//			AFX_MANAGE_STATE(AfxGetStaticModuleState());
//		// Hier normaler Funktionsrumpf
//		}
//
//		Es ist sehr wichtig, dass dieses Makro in jeder Funktion
//		vor allen MFC-Aufrufen erscheint. Dies bedeutet, dass es
//		als erste Anweisung innerhalb der Funktion ausgefhrt werden
//		muss, sogar vor jeglichen Deklarationen von Objektvariablen,
//		da ihre Konstruktoren Aufrufe in die MFC-DLL generieren
//		knnten.
//
//		Siehe MFC Technical Notes 33 und 58 fr weitere
//		Details.
//

/////////////////////////////////////////////////////////////////////////////
// CIn2catApp

BEGIN_MESSAGE_MAP(CIn2catApp, CWinApp)
	//{{AFX_MSG_MAP(CIn2catApp)
		// HINWEIS - Hier werden Mapping-Makros vom Klassen-Assistenten eingefgt und entfernt.
		//    Innerhalb dieser generierten Quelltextabschnitte NICHTS VERNDERN!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CIn2catApp Konstruktion

CIn2catApp::CIn2catApp()
{
	// ZU ERLEDIGEN: Hier Code zur Konstruktion einfgen
	// Alle wichtigen Initialisierungen in InitInstance platzieren
}

/////////////////////////////////////////////////////////////////////////////
// Das einzige CIn2catApp-Objekt

CIn2catApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CIn2catApp Initialisierung

BOOL CIn2catApp::InitInstance()
{
	if (!AfxSocketInit())
	{
		AfxMessageBox(IDP_SOCKETS_INIT_FAILED);
		return FALSE;
	}

	return TRUE;
}



// *******************************************************************************
//
// Hier die benutzerdefinierten Funktionen:
// ========================================
//


// Routine 0 
// BOOL win_sock_init(void );	 erzeugt ein CTimeOutSocket 
	static void win_sock_init(MPS_motregs *r)
	{
		AFX_MANAGE_STATE(AfxGetStaticModuleState());
		WSADATA wsd;
		WSAStartup(0x103,&wsd);
		r->d0=AfxSocketInit();
		hRasConn = NULL;
	}  
	
//	Routine 1 
// void *win_socket(void);
	static void win_socket(MPS_motregs *r)
	{
		AFX_MANAGE_STATE(AfxGetStaticModuleState());
//DYJ 2.06a Start
		CTimeOutSocket  *sock=new CTimeOutSocket ;
/*DYJ  Ende; alt:	
		CSocket *sock=new CSocket;
*/
//DYJ 1.07a Start
		r->a0=(long)sock;
/*DYJ  Ende; alt:	
		if(sock && sock->Create(0,r->d0))
			r->a0=(long)sock;
		else
			r->a0=NULL;
*/

	}

// Routine 2 win_connect fhrt ein connect durch
//	long win_connect(void* sock, const void *addr, long addrlen);
	static void win_connect(MPS_motregs *r)
	{
		AFX_MANAGE_STATE(AfxGetStaticModuleState());
//DYJ 2.06a Start
		CTimeOutSocket  *sock;
		SOCKADDR_IN sa;
		sock=(CTimeOutSocket *)(r->a0);
/*DYJ  Ende; alt:	
		CSocket *sock;
		SOCKADDR_IN sa;
		sock=(CSocket*)(r->a0);
*/
		if(sock->Connect(convSockAddr(&sa,r->a1),r->d0))
			r->d0=0;
		else
			r->d0=-sock->GetLastError();
	}
// Routine 8 win_connectC fhrt ein connect durch
//	long win_connectC(void* sock, char *url,ULONG port);
	static void win_connectC(MPS_motregs *r)
	{
		AFX_MANAGE_STATE(AfxGetStaticModuleState());
//DYJ 2.06a Start
		CTimeOutSocket  *sock;
		sock=(CTimeOutSocket *)(r->a0);
/*DYJ  Ende; alt:	
		CSocket *sock;
		sock=(CSocket*)(r->a0);
*/
		if(sock->Connect((char*)(*m_info.intel_ptr)(r->a1),r->d0))
			r->d0=0;
		else
			r->d0=-sock->GetLastError();

	}


// Routine 3 win_send sendet Daten
//	long win_send(void* s, const void *msg, long len, long flags);
	static void win_send(MPS_motregs *r)
	{
		AFX_MANAGE_STATE(AfxGetStaticModuleState());
//DYJ 2.06a Start
		CTimeOutSocket  *sock;
		void *lpBuf;
		sock=(CTimeOutSocket *)(r->a0);
/*DYJ  Ende; alt:	
		CSocket *sock;
		void *lpBuf;
		sock=(CSocket*)(r->a0);
*/
		lpBuf = (*m_info.intel_ptr)(r->a1);

		if((r->d0=sock->Send(lpBuf,r->d0,r->d1))==SOCKET_ERROR)
			r->d0=-sock->GetLastError();
	}


// Routine 4 win_recvfrom fhrt ein recvfrom durch
// long win_recvfrom(void* sock, void *buf, long len, long flags, void *from, long*fromlen,long timeOut);
//DYJ 2.06a Start
	static void win_recvfrom(MPS_motregs *r)
	{
		AFX_MANAGE_STATE(AfxGetStaticModuleState());
		CTimeOutSocket  *sock;
		void *lpBuf;
		int fromlen;
		int *lpFromlen;
		SOCKADDR_IN sa;
		sock=(CTimeOutSocket *)(r->a0);
		lpBuf = (*m_info.intel_ptr)(r->a1);
		lpFromlen = (int *)(*m_info.intel_ptr)(r->a3);
		TRACE("win_recvfrom: timeout:%d\n",r->d2);
		if(!sock->SetTimeOut(r->d2))
			TRACE("sockServer.SetTimeOut failed\n");
		if((r->d0=sock->ReceiveFrom(lpBuf,r->d0,convSockAddr(&sa,r->a2),&fromlen,r->d1))==SOCKET_ERROR)
			r->d0=-sock->GetLastError();
		if(!sock->KillTimeOut())
			TRACE("sockServer.KillTimeOut failed\n");
		*lpFromlen=(*m_info.swap_long)(fromlen);
	}
/*DYJ  Ende; alt:	
	static void win_recvfrom(MPS_motregs *r)
	{
		AFX_MANAGE_STATE(AfxGetStaticModuleState());
		CSocket *sock;
		void *lpBuf;
		int fromlen;
		int *lpFromlen;
		SOCKADDR_IN sa;
		sock=(CSocket*)(r->a0);
		lpBuf = (*m_info.intel_ptr)(r->a1);
		lpFromlen = (int *)(*m_info.intel_ptr)(r->a3);
		if((r->d0=sock->ReceiveFrom(lpBuf,r->d0,convSockAddr(&sa,r->a2),&fromlen,r->d1))==SOCKET_ERROR)
			r->d0=-sock->GetLastError();
		*lpFromlen=(*m_info.swap_long)(fromlen);
	}
*/

// Routine 5 win_sclose fhrt ein Close durch
// long win_sclose(void* sock);

	static void win_sclose(MPS_motregs *r)
	{
		AFX_MANAGE_STATE(AfxGetStaticModuleState());
//DYJ 2.06a Start
		CTimeOutSocket  *sock;
		sock=(CTimeOutSocket *)(r->a0);
/*DYJ  Ende; alt:	
		CSocket *sock;
		sock=(CSocket*)(r->a0);
*/
		sock->Close();
		delete sock;
		r->d0=0;
	}

// Routine 6 win_shutdown gibt die eigene IP zurck
// long win_shutdown(void* sock, long how);

	static void win_shutdown(MPS_motregs *r)
	{
		AFX_MANAGE_STATE(AfxGetStaticModuleState());
//DYJ 2.06a Start
		CTimeOutSocket  *sock;
		sock=(CTimeOutSocket *)(r->a0);
/*DYJ  Ende; alt:	
		CSocket *sock;
		sock=(CSocket*)(r->a0);
*/
		if(sock->ShutDown(r->d0))
			r->d0=0;
		else
			r->d0=-sock->GetLastError();
	}

// Routine 7 win_gethostname gibt die eigene IP als String zurck
// long win_gethostname(char *name, long len);

	static void win_gethostname(MPS_motregs *r)
	{
		AFX_MANAGE_STATE(AfxGetStaticModuleState());
		char *name;
		name = (char *) (*m_info.intel_ptr)(r->a0);
		r->d0=gethostname(name,r->d0);
	}
// Routine 9 win_inet_addr gibt die IP zu einer URL der Form a,b,c,d zurck
// long win_inet_addr(char *name);

	static void win_inet_addr(MPS_motregs *r)
	{
		AFX_MANAGE_STATE(AfxGetStaticModuleState());
		char *name;
		
		name = (char *) (*m_info.intel_ptr)(r->a0);
		r->d0=inet_addr(name);
	}
// Routine 10 dll_version gibt die Versionsnummer zurck
// short int dll_version(void);

	static void dll_version(MPS_motregs *r)
	{
		r->d0=DLL_VERS;
	}
// Routine 15 dll_versionAbwC gibt die Versionsnummer zurck bis zu der diese Version abwrtskompatibel ist
// short int dll_versionAbwC(void);

	static void dll_versionAbwC(MPS_motregs *r)
	{
		r->d0=DLL_ABW_VERS;
	}

	SOCKADDR *convSockAddr(SOCKADDR_IN *lpSockAddrZ,long motAddr)
	{
		AFX_MANAGE_STATE(AfxGetStaticModuleState());
		SOCKADDR_IN *lpSockAddrQ;
		lpSockAddrQ = (SOCKADDR_IN *) (*m_info.intel_ptr)(motAddr);
		if(lpSockAddrQ)
		{
			lpSockAddrZ->sin_family=(*m_info.swap_word)(lpSockAddrQ->sin_family);
			lpSockAddrZ->sin_port=(*m_info.swap_word)(lpSockAddrQ->sin_port);
			lpSockAddrZ->sin_addr.S_un.S_addr=(lpSockAddrQ->sin_addr.S_un.S_addr);	/* ja kein switch, da es nicht auf dien Zahlenwert sondern auf die Bytekombination ankommt*/
			return (SOCKADDR *)lpSockAddrZ;
		}
		else
			return NULL;
	}
// Routine 11 win_hasConn2In gibt die Anzahl der aktiven Verbindungen zum Internet zurck.
// long win_hasConn2In();
	static void win_hasConn2In(MPS_motregs *r)
	{
		AFX_MANAGE_STATE(AfxGetStaticModuleState());
		LPRASCONN  lpRasConn = NULL;
		LPRASCONN  lpTemp = NULL;
		DWORD cbBuf = 0;
		DWORD cConn = 0;
		DWORD dwRet = 0;

		// enumerate connections
		cbBuf = sizeof(RASCONN);
		if ( ((lpRasConn = ( LPRASCONN ) malloc((UINT)cbBuf)) != NULL ) )
		{            
			lpRasConn->dwSize = sizeof( RASCONN );                      
			dwRet = RasEnumConnections( lpRasConn, &cbBuf, &cConn );
			if ( dwRet == ERROR_BUFFER_TOO_SMALL )
			{
				if ( (lpTemp = ( LPRASCONN ) realloc(lpRasConn, (UINT)cbBuf) ) != NULL )
				{
					lpRasConn = lpTemp;
					dwRet = RasEnumConnections( lpRasConn, &cbBuf, &cConn );
                
				 }
				else
				{
					dwRet = ERROR_NOT_ENOUGH_MEMORY;
				}
			}
			else if ( dwRet != 0 ) // other error
				cConn=0;
		}

		if ( lpRasConn != NULL )
		{
			free( lpRasConn );
		}
		r->d0= cConn;
	}
// Routine 12 win_selConn whlt eine Verbindungsmglichkeiten zum Internet aus.
// long win_selConn(char *conn,size_t len,BOOL showStar);
	static void win_selConn(MPS_motregs *r)
	{
		AFX_MANAGE_STATE(AfxGetStaticModuleState());
		CESELINCONN dlg;
		char *conn;
		
		conn = (char *) (*m_info.intel_ptr)(r->a0);
//DYJ 1.05a Start
		dlg.m_conn=conn;
		dlg.m_bShowStar=r->d1;
		int ret=dlg.DoModal();
		if(!strcmp(STAR_TXT,dlg.m_conn))
			strncpy(conn,"*",r->d0);
		else
			strncpy(conn,dlg.m_conn,r->d0);
/*DYJ  Ende; alt:	
		dlg.m_conn=conn;
		int ret=dlg.DoModal();
		strncpy(conn,dlg.m_conn,r->d0);
*/
		r->d0=ret;
	}
// Routine 13 win_dial stellt eine Verbindung zum Internet her.
// long win_dial(char *conn,char *uName,char *uPassw);
	static void win_dial(MPS_motregs *r)
	{
		AFX_MANAGE_STATE(AfxGetStaticModuleState());
		RASDIALPARAMS rdParams;
		DWORD dwRet;
		char  *conn,*uName,*uPassw;

		conn = (char *) (*m_info.intel_ptr)(r->a0);
		uName = (char *) (*m_info.intel_ptr)(r->a1);
		uPassw = (char *) (*m_info.intel_ptr)(r->a2);
		// setup RAS Dial Parameters
		rdParams.dwSize = sizeof(RASDIALPARAMS);
		lstrcpy(rdParams.szEntryName, conn );
		rdParams.szPhoneNumber[0] = '\0';
		rdParams.szCallbackNumber[0] = '*';
		rdParams.szCallbackNumber[0] = '\0';

		rdParams.szDomain[0] = '*';
		rdParams.szDomain[1] = '\0';
		lstrcpy(rdParams.szUserName, uName );
		lstrcpy(rdParams.szPassword, uPassw );

		hRasConn = NULL;

	#ifdef WIN16
		rgmsdDialDlg[0].uMessage = RegisterWindowMessage(RASDIALEVENT);
		dwRet = RasDial( NULL, NULL, &rdParams, NULL, hdlg, &hRasConn );    
	#else
		dwRet = RasDial( NULL, NULL, &rdParams, 0L, (RASDIALFUNC) NULL, &hRasConn );
	#endif

		r->d0=dwRet;
	} 
// Routine 14 win_hangUp beendet eine Verbindung zum Internet.
// BOOL win_hangUp(char *name,size_t len);
	static void win_hangUp(MPS_motregs *r)
	{
		AFX_MANAGE_STATE(AfxGetStaticModuleState());
		
		LPRASCONN  lpRasConn = NULL;
		LPRASCONN  lpTemp = NULL;
		DWORD cbBuf = 0;
		DWORD cConn = 0;
		DWORD dwRet = 0;
		BOOL save=FALSE;
		char  *name;

		name = (char *) (*m_info.intel_ptr)(r->a0);
		if(!hRasConn)
		{
			// enumerate connections
			cbBuf = sizeof(RASCONN);
			hRasConn=NULL;
			if ( ((lpRasConn = ( LPRASCONN ) malloc((UINT)cbBuf)) != NULL ) )
			{            
				lpRasConn->dwSize = sizeof( RASCONN );                      
				dwRet = RasEnumConnections( lpRasConn, &cbBuf, &cConn );
				if ( dwRet == ERROR_BUFFER_TOO_SMALL )
				{
					if ( (lpTemp = ( LPRASCONN ) realloc(lpRasConn, (UINT)cbBuf) ) != NULL )
					{
						lpRasConn = lpTemp;
						dwRet = RasEnumConnections( lpRasConn, &cbBuf, &cConn );
                
					 }
				}
				if ( !dwRet)
				{
					if(!*name)
					{
						CEHangUp dlg(lpRasConn,cConn);
						if(dlg.DoModal()==IDOK)
						{
							strncpy(name,dlg.m_conn,r->d0);
							save=dlg.m_save;
						}
					}
					if(*name)
					{
/*DYJ 1.41a Start*/
						if(cConn==1 && !strcmp(name,"*"))
							hRasConn=lpRasConn[0].hrasconn;
						else
						{
							for (DWORD ndx = 0; ndx < cConn; ndx++ )
							{
								if(!strncmp(lpRasConn[ndx].szEntryName,name,r->d0))
								{
									hRasConn=lpRasConn[ndx].hrasconn;
									break;
								}
							}
						}
/*DYJ  Ende; alt:	
						for (DWORD ndx = 0; ndx < cConn; ndx++ )
						{
							if(!strncmp(lpRasConn[ndx].szEntryName,name,r->d0))
							{
								hRasConn=lpRasConn[ndx].hrasconn;
								break;
							}
						}
*/
					}
				}
			}

			if ( lpRasConn != NULL )
			{
				free( lpRasConn );
			}
		}

		if(hRasConn)
		{
			RasHangUp( hRasConn );
			hRasConn=NULL;
		}


		r->d0= save;
	}

// Thread-Routine zu  Routine 16 win4T_selConn whlt eine Verbindungsmglichkeiten zum Internet aus.
	UINT win4T_selConn(LPVOID pParam)
	{
		AFX_MANAGE_STATE(AfxGetStaticModuleState());
		CESELINCONN dlg;
//DYJ 1.05a Start
		SELCONN_DAT *pScd=(SELCONN_DAT *)pParam;
		dlg.m_conn=pScd->name;
		dlg.m_bShowStar=pScd->showStar;
		dlg.DoModal();
		if(!strcmp(STAR_TXT,dlg.m_conn))
			pScd->name="*";
		else
			pScd->name=dlg.m_conn;
/*DYJ  Ende; alt:	
		CString *pName=(CString *)pParam;
		dlg.m_conn=*pName;
		dlg.DoModal();
		*pName=dlg.m_conn;
*/
		
		ThreadStatus=2;
		return 0;
	}
// Routine 16 winT_selConn whlt eine Verbindungsmglichkeiten zum Internet aus, als Thread.
// void winT_selConn(char *name,size_t len,int *ret,BOOL showStar);
	static void winT_selConn(MPS_motregs *r)
	{
		AFX_MANAGE_STATE(AfxGetStaticModuleState());
//DYJ 1.05a Start
		static SELCONN_DAT scd;
/*DYJ  Ende; alt:	
		static CString name;
*/
		char *conn;
		conn = (char *) (*m_info.intel_ptr)(r->a0);
		switch(ThreadStatus)
		{
		case 0:	//keiner aktiv
//DYJ 1.05a Start
			scd.name=conn;
			scd.showStar=r->d1;
			ThreadStatus=1;
			AfxBeginThread(win4T_selConn,&scd,THREAD_PRIORITY_NORMAL);
/*DYJ  Ende; alt:	
			name=conn;
			ThreadStatus=1;
			AfxBeginThread(win4T_selConn,&name,THREAD_PRIORITY_NORMAL);
*/
		case 1:	//luft
			r->d0=0;
			break;
		case 2:	//fertig
			ThreadStatus=0;

//DYJ 1.05a Start
			strncpy(conn,scd.name,r->d0);
/*DYJ  Ende; alt:	
			strncpy(conn,name,r->d0);
*/
			r->d0=1;
		}
			
	}

// Thread-Routine zu  Routine 17 win4T_dial stellt eine Verbindung zum Internet her.
	UINT win4T_dial(LPVOID pParam)
	{
		AFX_MANAGE_STATE(AfxGetStaticModuleState());
		RASDIALPARAMS *pRdParams=(RASDIALPARAMS *)pParam;
#ifdef WIN16
		rgmsdDialDlg[0].uMessage = RegisterWindowMessage(RASDIALEVENT);
		ThreadReturn = RasDial( NULL, NULL, pRdParams, NULL, hdlg, &hRasConn );    
#else
		ThreadReturn = RasDial( NULL, NULL, pRdParams, 0L, (RASDIALFUNC) NULL, &hRasConn );
#endif
		ThreadStatus=2;
		return 0;
	}


// Routine 17 winT_dial stellt eine Verbindung zum Internet her.per Thread
// long win_dial(char *conn,char *uName,char *uPassw);
	static void winT_dial(MPS_motregs *r)
	{
		AFX_MANAGE_STATE(AfxGetStaticModuleState());
		static RASDIALPARAMS rdParams;
		char  *conn,*uName,*uPassw;
		switch(ThreadStatus)
		{
		case 0:	//keiner aktiv

			conn = (char *) (*m_info.intel_ptr)(r->a0);
			uName = (char *) (*m_info.intel_ptr)(r->a1);
			uPassw = (char *) (*m_info.intel_ptr)(r->a2);
			// setup RAS Dial Parameters
			rdParams.dwSize = sizeof(RASDIALPARAMS);
			lstrcpy(rdParams.szEntryName, conn );
			rdParams.szPhoneNumber[0] = '\0';
			rdParams.szCallbackNumber[0] = '*';
			rdParams.szCallbackNumber[0] = '\0';

			rdParams.szDomain[0] = '*';
			rdParams.szDomain[1] = '\0';
			lstrcpy(rdParams.szUserName, uName );
			lstrcpy(rdParams.szPassword, uPassw );

			hRasConn = NULL;
			ThreadStatus=1;
			AfxBeginThread(win4T_dial,&rdParams,THREAD_PRIORITY_NORMAL);
		case 1:	//luft
			r->d0=-1;;
			break;
		case 2:	//fertig
			ThreadStatus=0;
			r->d0=ThreadReturn;
		}
			
	}
// Thread-Routine zu  Routine 18 init_clock aktualisiert regelmig die Zeit.
	UINT init_clockT(LPVOID pParam)
	{
		AFX_MANAGE_STATE(AfxGetStaticModuleState());
		clock_t *zeit;
		zeit=(clock_t*)pParam;
		while(1)
		{
			*zeit=(*m_info.swap_long)(clock());
//			TRACE("Zeit: %d",*zeit);
		}
		return 0;
	}

// Routine 18 init_clock initialisiert CLOCK-Thread
// void init_clock(clock_t *zeit);
	static void init_clock(MPS_motregs *r)
	{
		AFX_MANAGE_STATE(AfxGetStaticModuleState());
		clock_t *zeit;
		zeit = (clock_t *) (*m_info.intel_ptr)(r->a0);
		*zeit=(*m_info.swap_long)(clock());
		AfxBeginThread(init_clockT,zeit,THREAD_PRIORITY_NORMAL);
	}
//** ------------------------------------------------------------------------ **
// Routine 19 win_clock gibt clock() zurck
// clock_t win_clock(void)
//								
//	Parameter:	keine															
//	Ergebnis:	Prozesszeit in ms																	
//	29.11.02 von Dimitri Junker	DYJ 1.06a										
//** ------------------------------------------------------------------------ **
	static void win_clock(MPS_motregs *r)
	{
		AFX_MANAGE_STATE(AfxGetStaticModuleState());
		r->d0=clock();
	}
//** ------------------------------------------------------------------------ **
// Routine 20 win_gethostIP gibt die eigene IP als long zurck
// unsigned long win_gethostIP(void);
//								
//	Parameter:	keine															
//	Ergebnis:	IP als long																	
//	1.2.03 von Dimitri Junker	DYJ 1.07a										
//** ------------------------------------------------------------------------ **

	static void win_gethostIP(MPS_motregs *r)
	{
		AFX_MANAGE_STATE(AfxGetStaticModuleState());
		char name[200];
		hostent *he;
		unsigned int ip;
		r->d0=gethostname(name,r->d0);
		TRACE("Name:%s\n",name);
		he=gethostbyname(name);
		ip=*((int*)he->h_addr);
		TRACE("IP:%i\n",ip);
		r->d0=m_info.swap_long(ip);
	}
//** ------------------------------------------------------------------------ **
//	Routine 21	win_lstErr gibt die Nummer des letzten Fehlers zurck				
//	_ULONG win_lstErr(void* sock);							
//	Parameter:	sock: der Socket															
//	Ergebnis:	Fehlernummer																	
//	8.3.03 von Dimitri Junker	DYJ 1.07b										
//** ------------------------------------------------------------------------ **
//	Routine 21 
// _ULONG win_lstErr(void* sock);
	static void win_lstErr(MPS_motregs *r)
	{
		AFX_MANAGE_STATE(AfxGetStaticModuleState());
//DYJ 2.06a Start
		CTimeOutSocket  *sock;
		sock=(CTimeOutSocket*)(r->a0);
/*DYJ  Ende; alt:	
		CSocket *sock;
		sock=(CSocket*)(r->a0);
*/
		r->d0=sock->GetLastError();
		return;
	}

//** ------------------------------------------------------------------------ **
//	Routine 22 BOOL win_create(void* sock,long type);
//						
//								
//	Parameter:	keine															
//	Ergebnis:	keines																	
//	8.3.03 von Dimitri Junker	DYJ 1.07b										
//** ------------------------------------------------------------------------ **
	static void win_create(MPS_motregs *r)
	{
		AFX_MANAGE_STATE(AfxGetStaticModuleState());
//DYJ 2.06a Start
		CTimeOutSocket  *sock;
		sock=(CTimeOutSocket *)(r->a0);
/*DYJ  Ende; alt:	
		CSocket *sock;
		sock=(CSocket*)(r->a0);
*/
		r->d0=sock->Create(0,r->d0);
	}





