/********************************************************************/
/*	EASYFSEL.H														*/
/*																	*/
/*	Include-Datei zu EASYFSEL.C.									*/
/*																	*/
/*	Revision: 6														*/
/*	Datum   : 15.06.1992											*/
/*  Autor   : Andreas Papula										*/
/*																	*/
/*	Copyright 1992 by MAXON Computer GmbH.							*/
/*			abgespeckte Version fr In2Cat							*/
/********************************************************************/

/* -------------------------------------------------------------------- */
/*		Includes														*/
/* -------------------------------------------------------------------- */
#include <stdio.h>
#include <portab.h>
#include <tos.h>

/* -------------------------------------------------------------------- */
/*       Makros. & Konstanten                                           */
/* -------------------------------------------------------------------- */

typedef char	BOOLEAN;
#ifndef BOOLDEF
typedef char	BOOL;
#define BOOLDEF
#endif

/*	d_case_s enthlt die Info ob das aktuell mit Fsfirst untersuchte
	Verzeichnis case sensitiv ist (Rckgabe von Dpathconv(6))
	0 = Unterscheidung zwischen Gro-/Kleinschreibung.
	1 = keine Unterscheidung zwischen Gro-/Kleinschreibung (alle
	 Zeichen werden entweder in Gro-,oder in Kleinbuchstaben umgewandelt).
	2 = keine Unterscheidung zwischen Gro-/Kleinschreibung. Das Dateisystem
	 speichert aber Pfad- und Dateinamen mit den Originalwerten ab.
*/	
#define CASE_SENS	0				
#define CASE_CHG	1				
#define CASE_KEEP	2				

/* die in d_flags verwendeten Bits: */
/* DTF_DO gibt an ob Dopendir, Dreaddir und Dclosedir vorhanden sind	*/
/* DTF_FX gibt an ob Fxattr vorhanden ist	*/
/* DTF_DX gibt an ob Dxreaddir vorhanden ist	*/

#define DTF_DO	1
#define DTF_FX	2
#define DTF_DX	4

#define TRUE 1
#define FALSE 0

/*------------------------------------------------------------------*/
/*	Funktionsprototypen.																						*/
/*------------------------------------------------------------------*/

void build_filename(BYTE *dest, BYTE *pfad, BYTE *dateiname,BOOLEAN noFinPf);
int cmp_maske(char *str,char *maske,int ign_case);
long Dxreaddir(int len,long dirhandle, char *buf,XATTR *xatttr,long *xret);
BOOLEAN easy_fsel(BYTE *pfad, BYTE *dateiname, BYTE *text);
BOOLEAN exist(const BYTE *dateiname,int case_ign);
BOOLEAN exist_dir(const BYTE *dateiname,int case_ign);
BOOLEAN exist_dirOfFile(const BYTE *file,int case_ign);	/*DYJ 1.46b */
int fsfirst( const char *filename, int attr,int case_ign );
int fsnext(void);
BYTE *get_akt_path(BYTE *path);
BOOLEAN get_cookie(long cookie_name, LONG *cookie_value);
FILE *tmp_tmpfile(void);
void tmpFilename(char *buf,char *ext);
void trenn_pfad(char *pfad,char *name,const char *file);
void unQuote(char *ziel, const char *quell,BOOLEAN blkIsEnd);

/*----------------------- Ende der Datei. --------------------------*/