/*			FENSTER.H V 2.0
		(c) 1996 by Dimitri Junker
			Adenauerallee 30
			52066 Aachen
			abgespeckte Version fr In2Cat
			
		Dieses File ist Teil des In2Cat-Projektes und steht unter der
		In2Cat Public License. Dementspechend ist es Freeware und darf
		entsprechend der o.g. Liscense weitergegeben und verndert werden.
		Eine Kopie der In2Cat Public License liegt diesem Paket bei
		Diese Copyright Meldung darf nur vom Copyright Inhaber gendert werden.
*/

#if  !defined( FENSTNC_H )
#define FENSTNC_H


/* -------------------------------------------------------------------- */
/*		Includes														*/
/* -------------------------------------------------------------------- */

#include <aes.h>
#include <my_ext.h>
/* -------------------------------------------------------------------- */
/*       Makros. & Konstanten                                           */
/* -------------------------------------------------------------------- */
/* Fehler	*/
#define ERR_FE_SPEI	(ERR_FENSTER+ERR_SPEI)	/*zu Wenig Speicher			*/
#define ERR_FE_FREE	(ERR_FENSTER+ERR_FREE)	/*Fehler bei FREE			*/
#define ERR_FE_TERM	(ERR_FENSTER+ERR_TERM)	/*APP_TERM o..				*/
#define ERR_FE_ABB	(ERR_FENSTER+ERR_ABB)	/* Abbruch					*/
#define ERR_FE_DNB	(ERR_FENSTER+ERR_IONB)	/*Drucker nicht bereit		*/
#define ERR_FE_UTC	(ERR_FENSTER-1)		/*Unbekanntes TC Format		*/
#define ERR_FE_UNBF	(ERR_FENSTER-2)		/*Unbekanntes Fenster		*/
#define ERR_FE_STD	(ERR_FENSTER-3)		/*Falscher fd_stand			*/
#define ERR_FE_UNBM	(ERR_FENSTER-4)		/*Unbekannte Message		*/
#define ERR_FE_INIT	(ERR_FENSTER-5)		/*Fehler bei INIT		*/
#define ERR_FE_CFG	(ERR_FENSTER-6)		/*Fehler im CFG File		*/

#define		FE_PRO		3003
/* f_flags	*/
#define FE_ISFULL	0x100	/*	ist Full						*/
#define FE_OBJECT	0x200	/*	ist OBJECT						*/
#define FE_ICONIF	0x400	/*	ist iconifiziert mit oder ohne Icon	*/
#define FE_LUPE		0x800	/*	ist Lupe						*/

/*	zum Testen noch:	*/
#define FE_TYP		(FE_OBJECT|FE_ICONIF)	/* nur die interessanten Bits*/
#define FE_BILD		0		/* nichts spezielles gesetzt		*/

#define min(a, b)             ((a) < (b) ? (a) : (b))
#define max(a, b)             ((a) > (b) ? (a) : (b))


/* AV-Protokoll		*/
#define		AV_PROTOKOLL		(0x4700)
#define		AV_STARTPROG		(0x4722)
#define		AV_SENDKEY			(0x4710)
#define		AV_STARTED			(0x4738)
#define		AV_ACCCWINDOPEN 	(0x4724)
#define		AV_ACCCWINDCLOSED	(0x4726)
#define		AV_EXIT				(0x4736)

#define		VA_PROTOSTATUS		(0x4701)
#define		VA_PROGSTART		(0x4723)
#define		VA_START			(0x4711)
/* die bits fr AV_PROTOKOLL		*/
#define		AVF_SETSTATUS		1
#define		AVF_START			2
#define		AVF_STARTED			4
#define		AVF_FONTCHANGED		8
#define		AVF_QUOTING			16
#define		AVF_PATH_UPDATE		32

#define		BIT0_7				{1,2,4,8,16,32,64,128}
#define	DR_BEF_LEN	20


#define		AV_SERVER 	"GEMINI  ","JINNEE  ","THING   ","EASE    ","AVSERVER","MAGXDESK","CAT     "
#define		ANZ_AVSERV	7

#define 	ACTIVE			EXTSTAT15

/* -------------------------------------------------------------------- */
/*		typedefs														*/
/* -------------------------------------------------------------------- */

/* Infos fr die verschiedenen Protokolle: AV	*/
typedef struct
{	int		id_stg;			/* ST-Guide ID							*/
	int		id_avserv;		/* der AV_SERVER						*/
	int		av_flag0;		/* untersttzte Flags des eigenen PRG	*/
	int		av_flag1;		/* untersttzte Flags des AV_SERVER		*/
	int		av_flag2;		/* untersttzte Flags des AV_SERVER		*/
}PROT_INF;

typedef union fspecptr	
{	MFDB	*mfdbx;
	OBJECT	*obj;
}FSPEC;

#ifndef BOOLDEF
typedef char	BOOL;
#define BOOLDEF
#endif

typedef struct
{	int		nxt_ob,		/* next_object	*/
			edt_ob,		/* edit_object	*/
			def_ob,		/* Default Obj	*/
			drw_ob,		/* Zeichnen ab	*/
			sel_ob,		/* selektiertes Objekt*/
			idx,
			id_ob;		/* Id des Objects	*/
	BOOL	cur_on;
}FDWI;

typedef union finf
{	MFDB	*mfdbx[8];
	FDWI	fdw;
	struct FEN *q_fen;
}FINF;

typedef struct	FEN /* Enthlt Daten eines Fensters	bei fremden 
	 Fenstern ist nur f_hdl,f_own und f_nxt gesetzt				*/
{	int		f_ax;		/*	zuerst die aktuellen Parameter		*/
	int		f_ay;
	int		f_aw;
	int		f_ah;
	int		f_fx;		/*	jetzt die gemerkten fr FULL		*/
	int		f_fy;
	int		f_fw;
	int		f_fh;
	int		f_hdl;		/* Handel des Fensters				 	*/
	int		f_own;		/* Der Besitzer des Fensters, an den ggf eine MSG gesendet werden soll*/
    int		f_k;		/* Integerparameter der alle Komponenten des Fensters beeinhaltet*/
	int		f_ox;		/* Offset in x						 	*/
	int		f_oy;		/* Offset in y							*/
	int		f_flags;	/* Bit 0-7 Plane zeigen?
						   Bit 8-15 s. FE_OBJECT...:				*/
	int		f_icon_by;	/* -1: nicht iconifiziert
							f_hdl	iconifiziert mit Icon
							sonst:	iconifiziert ohne Icon durch f_icon_by*/
	OBJECT	*f_icon;	/* das Icon zum iconifizieren			*/
	FSPEC	f_vb;		/* max ein MFDB/OBJECT pro plane		*/
	FINF	f_i;		/* Normales Fenster: die Original MFDBs
						   Objektfenster:Infos fr form_do
						   Lupenfenster Quellfenster, NULL f. Desktop*/
	int		f_slh;		/* Position des horizontalen Sliders 	*/
	int		f_slv;		/* Position des vertikalen Sliders 		*/
	int		f_sldh[8];	/* Deltas fr horizontalen Slider 		*/
	int		f_sldv[8];	/* Deltas fr vertikalen Slider 		*/
	int		f_lup_m;	/* Lupenmodus s. LUP_1STD...			*/
	struct FEN *f_nxt;	/* Das nchste Fenster					*/
	char	*f_clut_name;	/* Die CLUT des Originalbildes		*/
} FENSTER;
typedef struct
{	int		gm_ahdl;	/* ID von appl_init						*/
	int		gm_vhdl;	/* VDI Handle							*/
	char	*gm_name;	/* Programmname							*/
	MFDB	*gm_dsk;	/* Desktop								*/
	FENSTER	*gm_tw;		/* das oberste Fenster					*/
	BITBLK	*gm_icon;	/* zum iconifizieren					*/
}GEM_INF;

/* -------------------------------------------------------------------- */
/*		Globale Variablen												*/
/* -------------------------------------------------------------------- */
extern PROT_INF Prot_inf;
extern GEM_INF Gem_inf;
/* -------------------------------------------------------------------- */
/* 		Funktionsprototypen												*/
/* -------------------------------------------------------------------- */
void einf_fenster(FENSTER *fenster);
int fenst_4_obj(OBJECT *ob_drtree,char *fenstertitel,int id);
void del_fenst_4_obj(int ob_win);
int do_msg_win(int *ev_mgpbuff);
void entf_fenster(int hdl,int flags);
void exit_fenster(void);
FENSTER *fdw_do(int *which,int *msg,int kr,int ks,int mx,int my,int br);
void fdw_ini(int fenster,int start_field);
FENSTER *find_fenst(int hdl,int flags);
int init_fenster(char *my_name);
void mkLogName(char *lPfad,size_t len);
void redraw(int wh,GRECT *area,int start);
void select_rb(OBJECT obj[],int set_nr);
void send_av_prot(void);
int send_av_stpr(int z_id,char *prg_name,char *cmd,int id);
void send_va_proto(int z_id,int flags);
int send_va_start(int z_id,char *cmd);
int what_rb(OBJECT obj[],int rahmen);
void send_av_exit(void);
int d_satz(int alt,int alt_max,int neu_max);

#endif