/*			MY_EXT.H V 2.00
		(c) 1996 by Dimitri Junker
			Adenauerallee 30
			52066 Aachen
			
			abgespeckte Version fr In2Cat
			
		Dieses File ist Teil des In2Cat-Projektes und steht unter der
		In2Cat Public License. Dementspechend ist es Freeware und darf
		entsprechend der o.g. Liscense weitergegeben und verndert werden.
		Eine Kopie der In2Cat Public License liegt diesem Paket bei
		Diese Copyright Meldung darf nur vom Copyright Inhaber gendert werden.
*/

#if  !defined( MY_EXT_H )
#define MY_EXT_H

/* -------------------------------------------------------------------- */
/*		Includes														*/
/* -------------------------------------------------------------------- */
#include <stdio.h>
#include <portab.h>
#include <vdi.h>

/* -------------------------------------------------------------------- */
/*		typedefs 														*/
/* -------------------------------------------------------------------- */

typedef union 
{	unsigned char	c[4];
	unsigned long	l;
}C_OR_L;

/* -------------------------------------------------------------------- */
/*       Makros. & Konstanten                                           */
/* -------------------------------------------------------------------- */
/* mode Bits fr Mxalloc	*/

/* Object flags */
/* DYJ von mir eingefgt	*/
#define EXTFLAG12		0x1000
#define EXTFLAG13		0x2000
#define EXTFLAG14		0x4000
#define EXTFLAG15		0x8000

/* Object states */
/* DYJ von mir eingefgt	*/
#define EXTSTAT8		0x0100
#define EXTSTAT9		0x0200
#define EXTSTAT10		0x0400
#define EXTSTAT11		0x0800
#define EXTSTAT12		0x1000
#define EXTSTAT13		0x2000
#define EXTSTAT14		0x4000
#define EXTSTAT15		0x8000

#define WM_BOTTOMED		33

#define	MXST		0x0
#define	MXTT		0x1
#define	MXSTTT		0x2
#define	MXTTST		0x3
#define	MXPRGF		0x8
#define	MXPRIV		0x18
#define	MXGLOB		0x28
#define	MXSUP		0x38
#define	MXROM		0x48
#define	MXNFRE		0x4000

#define ERR_STD	-0x80	
#define ERR_BIB		0xff00		/* zum Extrahieren der Bibliothek	*/
#define ERR_NBIB	0xff		/* zum Extrahieren des Restes	*/

#define err_bib(e)	(((-(e))&ERR_BIB)>>8)
#define err_nbib(e)	(-((-(e))&ERR_NBIB))

/* bei jeder Gruppe sind die mit ERR_STD Standardfehler,die anderen spezielle		*/
/* von 0 bis 0xff Fehler des Hauptprgs 								*/

#define ERR_FREE	(ERR_STD-2)			/*Fehler bei FREE			*/
#define ERR_VNUM	(ERR_STD-3)			/*unbekannte Versionsnummer	*/
#define ERR_UFF		(ERR_STD-11)			/*unbekanntes File-Format	*/
#define ERR_IONB	(ERR_STD-12)			/*I/O nicht bereit			*/
#define	ERR_FIO		(ERR_STD-13)			/*Fehler bei I/O-Operation	*/
#define	ERR_TERM	(ERR_STD-14)			/* TERM						*/
#define ERR_UPAR	(ERR_STD-15)			/* Unbekannter Parameter	*/
#define ERR_RSC		(ERR_STD-17)			/* RSC nicht gefunden o..	*/
#define ERR_ABB		(ERR_STD-32)			/* Abbruch					*/
#define ERR_SPEI	(ERR_STD-39)			/*zu Wenig Speicher			*/
#define ERR_INT		(ERR_STD-41)			/*Interner Fehler			*/

/* von -0x100 bis -0x1ff Fehler in GR_FILE								*/
#define ERR_GRFILE	-0x100

/* von -0x200 bis -0x2ff Fehler in FENSTER								*/
#define ERR_FENSTER	-0x200


/* von -0x600 bis -0x6ff Fehler in EASY_FSEL							*/

#define ERR_FS	-0x600

/* von -0x700 bis -0x7ff Fehler in in2cat							*/

#define ERR_I2C	-0x700
typedef struct
{
    LONG id;             /* Identifikations-Code */
    LONG value;          /* Wert des Cookies     */
} COOKJAR;

#define S_INQUIRE	-1
#define S_GETCOOKIE	8
#define E_OK		0

/* -------------------------------------------------------------------- */
/* 		Funktionsprototypen												*/
/* -------------------------------------------------------------------- */

void set_errm(int bibl,int (meldungen)(char *,int));
void *my_mxalloc(size_t laenge,int mode);
long Ssystem(int  mode,long arg1,long arg2);		/*DYJ 2.03b */
#endif